// Time-stamp: <97/08/27 17:04:19 zaykin> (Dmitri Zaykin)
//

// s -- an array to search (it should be sorted already!)
// c -- number to compare with
// len -- the length of that array
// index -- the position of the number that is found (the one to the right)
// (the function returns that number)

double CSearch(double *s, double c, int len, int *index)
{
    int l=0; int r=len;
    while(r >= l)
    {
        int x=(l+r)/2;
        if( x > 0 && s[x-1] <= c && s[x] >= c ) { return s[*index=x]; }
        else if(!x) { return s[*index=0]; }
        if( c < s[x] ) r=x;
        else l=x+1;
    }
    return -1;
}


// Example of usage :

// #include <iostream.h>  

// int main()
// {
//         // sorted array
//     double x[] = { 0.1, 0.92, 1.23, 5.49, 10.6, 33.41, 208.4, 506.2 };
//     int n = 8; // it's length
//     double searchfor = 6.2;
//     int where;
//     double what;
    
//     cout << "\nLooking for the pair of numbers in the array ";
//     cout << "that are closest to " << searchfor << "... ";
//     what = CSearch(x, searchfor, n, &where);
//     cout << "\n\nThe closest number from the right side is " << what << "\n";
//     cout << "It's index in the array is " << where << "\n";
//     if(where != 0) {
//         cout << "\nThe closest number from the left side is " << x[where-1] << "\n";
//         cout << "It's index in the array is " << (where-1) << "\n";
//     }
//     return 0;
// }
